Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 2693)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file time_integration.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,19 @@
 ! -----------------
 ! $Id$
+! - Implementation of uv exposure model (FK)
+! - Moved vnest_boundary_conds_khkm from tcm_diffusivities to here (TG)
+! - renamed diffusivities to tcm_diffusivities (TG)
+! - implement prognostic equation for diss (TG)
+! - Moved/commented CALL to chem_emissions (FK)
+! - Added CALL to chem_emissions (FK)
+! - Implementation of chemistry module (FK)
+! - Calls for setting boundary conditions in USM and LSM (MS)
+! - Large-scale forcing with larger-scale models implemented (MS)
+! - Rename usm_radiation into radiation_interactions; merge with branch 
+!   radiation (MS)
+! - added call for usm_green_heat_model for green building surfaces (RvT)
+! - added call for usm_temperature_near_surface for use in indoor model (RvT)
+! 
+! 2617 2017-11-16 12:47:24Z suehring
 ! Bugfix, assure that the reference state does not become zero.
 ! 
@@ -287,5 +302,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  diss, dzu, e, e_p, nc, nc_p, nr, nr_p, prho, pt, pt_p, pt_init, &
+        ONLY:  diss, diss_p, dzu, e, e_p, nc, nc_p, nr, nr_p, prho, pt, pt_p, pt_init, &
                q_init, q, qc, qc_p, ql, ql_c, ql_v, ql_vp, qr, qr_p, q_p,      &
                ref_state, rho_ocean, s, s_p, sa_p, tend, u, u_p, v, vpt,       &
@@ -295,7 +310,15 @@
         ONLY:  calc_mean_profile
 
+#if defined( __chem )
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_emissions, chem_species
+
+    USE chem_modules,                                                          &
+        ONLY:  nspec 
+#endif
+
     USE control_parameters,                                                    &
-        ONLY:  advected_distance_x, advected_distance_y, average_count_3d,     &
-               averaging_interval, averaging_interval_pr,                      &
+        ONLY:  advected_distance_x, advected_distance_y, air_chemistry,        &
+               average_count_3d, averaging_interval, averaging_interval_pr,    &
                bc_lr_cyc, bc_ns_cyc, bc_pt_t_val,                              &
                bc_q_t_val, call_psolver_at_all_substeps, cloud_droplets,       &
@@ -307,6 +330,6 @@
                dt_coupling, dt_data_output_av, dt_disturb, dt_do2d_xy,         &
                dt_do2d_xz, dt_do2d_yz, dt_do3d, dt_domask,dt_dopts, dt_dopr,   &
-               dt_dopr_listing, dt_dots, dt_dvrp, dt_run_control,              &
-               end_time, first_call_lpm, galilei_transformation, humidity,     &
+               dt_dopr_listing, dt_dots, dt_dvrp, dt_run_control, end_time,    &
+               first_call_lpm, forcing, galilei_transformation, humidity,      &
                intermediate_timestep_count, intermediate_timestep_count_max,   &
                land_surface, large_scale_forcing,                              &
@@ -316,5 +339,5 @@
                ocean, passive_scalar,                                          &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
-               run_coupled, simulated_time, simulated_time_chr,                &
+               rans_tke_e, run_coupled, simulated_time, simulated_time_chr,    &
                skip_time_do2d_xy, skip_time_do2d_xz, skip_time_do2d_yz,        &
                skip_time_do3d, skip_time_domask, skip_time_dopr,               &
@@ -328,6 +351,6 @@
                turbulent_inflow, turbulent_outflow, urban_surface,             &
                use_initial_profile_as_reference,                               &
-               use_single_reference_value, u_gtrans, v_gtrans, virtual_flight, &
-               wind_turbine, ws_scheme_mom, ws_scheme_sca
+               use_single_reference_value, uv_exposure, u_gtrans, v_gtrans,    &
+               virtual_flight, wind_turbine, ws_scheme_mom, ws_scheme_sca
 
     USE cpulog,                                                                &
@@ -349,9 +372,13 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  lsm_energy_balance, lsm_soil_model,                             &
+        ONLY:  lsm_boundary_condition, lsm_energy_balance, lsm_soil_model,     &
                skip_time_do_lsm
 
     USE lsf_nudging_mod,                                                       &
-        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref
+        ONLY:  calc_tnudge, ls_forcing_surf, ls_forcing_vert, nudge_ref,       &
+               forcing_bc, forcing_bc_mass_conservation
+
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  force, netcdf_data_input_lsf
 
     USE microphysics_mod,                                                      &
@@ -368,7 +395,4 @@
                pmci_ensure_nest_mass_conservation, pmci_synchronize
 
-    USE production_e_mod,                                                      &
-        ONLY:  production_e_init
-
     USE progress_bar,                                                          &
         ONLY:  finish_progress_bar, output_progress_bar
@@ -379,4 +403,5 @@
     USE radiation_model_mod,                                                   &
         ONLY: dt_radiation, force_radiation_call, radiation, radiation_control,&
+              radiation_interaction, radiation_interactions,                   &
               skip_time_do_radiation, time_radiation
 
@@ -395,7 +420,12 @@
         ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
 
+    USE turbulence_closure_mod,                                                &
+        ONLY:  tcm_diffusivities, production_e_init
+
     USE urban_surface_mod,                                                     &
-        ONLY:  usm_material_heat_model, usm_material_model,                    &
-               usm_radiation, usm_surface_energy_balance
+        ONLY:  usm_boundary_condition, usm_material_heat_model,                &
+               usm_material_model,                                             &
+               usm_surface_energy_balance, usm_green_heat_model,               &
+               usm_temperature_near_surface
 
     USE synthetic_turbulence_generator_mod,                                    &
@@ -404,4 +434,7 @@
     USE user_actions_mod,                                                      &
         ONLY:  user_actions
+
+    USE uv_exposure_model_mod,                                                 &
+        ONLY:  uvem_calc_exposure
 
     USE wind_turbine_model_mod,                                                &
@@ -417,8 +450,9 @@
 
     CHARACTER (LEN=9) ::  time_to_string          !< 
+    INTEGER           ::  n
+    INTEGER           ::  lsp
 
     REAL(wp) ::  dt_3d_old  !< temporary storage of timestep to be used for
                             !< steering of run control output interval
-
 !
 !-- At beginning determine the first time step
@@ -501,4 +535,11 @@
            bc_q_t_val  = ( q_init(nzt+1) - q_init(nzt) ) / dzu(nzt+1)
        ENDIF
+!
+!--    If forcing by larger-scale models is applied, check if new data
+!--    at domain boundaries need to be read.
+       IF ( forcing )  THEN
+          IF ( force%time(force%tind_p) <= simulated_time )                    &
+             CALL netcdf_data_input_lsf
+       ENDIF
 
 !
@@ -617,4 +658,12 @@
           CALL exchange_horiz( pt_p, nbgp )
           IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e_p, nbgp )
+          IF ( rans_tke_e  .OR.  wang_kernel  .OR.  collision_turbulence       &
+               .OR.  use_sgs_for_particles )  THEN
+             IF ( rans_tke_e )  THEN
+                CALL exchange_horiz( diss_p, nbgp )
+             ELSE
+                CALL exchange_horiz( diss, nbgp )
+             ENDIF
+          ENDIF
           IF ( ocean )  THEN
              CALL exchange_horiz( sa_p, nbgp )
@@ -639,10 +688,12 @@
              CALL exchange_horiz( ql_vp, nbgp )
           ENDIF
-          IF ( wang_kernel  .OR.  collision_turbulence  .OR.                &
-               use_sgs_for_particles )  THEN
-             CALL exchange_horiz( diss, nbgp )
-          ENDIF
           IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
-
+#if defined( __chem )
+          IF ( air_chemistry )  THEN
+             DO  n = 1, nspec     
+                CALL exchange_horiz( chem_species(n)%conc_p, nbgp ) 
+             ENDDO
+          ENDIF
+#endif
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
@@ -756,5 +807,5 @@
                    CALL disturb_field( 'v', tend, v )
                 ELSEIF ( ( .NOT. bc_lr_cyc  .OR.  .NOT. bc_ns_cyc )            &
-                     .AND. .NOT. nest_domain )  THEN
+                     .AND. .NOT. nest_domain  .AND.  .NOT.  forcing )  THEN
 !
 !--                Runs with a non-cyclic lateral wall need perturbations
@@ -770,4 +821,15 @@
 
 !
+!--       Map forcing data derived from larger scale model onto domain 
+!--       boundaries. 
+          IF ( forcing  .AND.  intermediate_timestep_count ==                  &
+                               intermediate_timestep_count_max  )  THEN
+             CALL forcing_bc
+          ENDIF
+!
+!--       Moreover, ensure mass conservation at each RK substep.
+          IF ( forcing )  CALL forcing_bc_mass_conservation
+
+!
 !--       Reduce the velocity divergence via the equation for perturbation
 !--       pressure.
@@ -833,9 +895,8 @@
                 CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'stop' )
              ENDIF
-
 !
 !--          If required, solve the energy balance for the surface and run soil 
 !--          model. Call for horizontal as well as vertical surfaces
-             IF ( land_surface .AND. time_since_reference_point > skip_time_do_lsm)  THEN
+             IF ( land_surface .AND. time_since_reference_point >= skip_time_do_lsm)  THEN
 
                 CALL cpu_log( log_point(54), 'land_surface', 'start' )
@@ -860,8 +921,12 @@
                 CALL lsm_energy_balance( .FALSE., 3 )
                 CALL lsm_soil_model( .FALSE., 3, .TRUE. )
+!
+!--             At the end, set boundary conditons for potential temperature
+!--             and humidity after running the land-surface model. This 
+!--             might be important for the nesting, where arrays are transfered.
+                CALL lsm_boundary_condition
 
                 CALL cpu_log( log_point(54), 'land_surface', 'stop' )
              ENDIF
-
 !
 !--          If required, solve the energy balance for urban surfaces and run 
@@ -871,9 +936,17 @@
                 CALL usm_surface_energy_balance
                 IF ( usm_material_model )  THEN
+                   CALL usm_green_heat_model
                    CALL usm_material_heat_model
                 ENDIF
+
+                CALL usm_temperature_near_surface
+!
+!--             At the end, set boundary conditons for potential temperature
+!--             and humidity after running the urban-surface model. This 
+!--             might be important for the nesting, where arrays are transfered.
+                CALL usm_boundary_condition
+
                 CALL cpu_log( log_point(74), 'urban_surface', 'stop' )
              ENDIF
-
 !
 !--          Compute the diffusion coefficients
@@ -881,13 +954,15 @@
              IF ( .NOT. humidity ) THEN
                 IF ( ocean )  THEN
-                   CALL diffusivities( prho, prho_reference )
+                   CALL tcm_diffusivities( prho, prho_reference )
                 ELSE
-                   CALL diffusivities( pt, pt_reference )
+                   CALL tcm_diffusivities( pt, pt_reference )
                 ENDIF
              ELSE
-                CALL diffusivities( vpt, pt_reference )
-             ENDIF
-
+                CALL tcm_diffusivities( vpt, pt_reference )
+             ENDIF
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
+!
+!--          Vertical nesting: set fine grid eddy viscosity top boundary condition
+             IF ( vnest_init )  CALL vnest_boundary_conds_khkm
 
           ENDIF
@@ -914,8 +989,9 @@
                 CALL cpu_log( log_point(50), 'radiation', 'stop' )
 
-                IF (urban_surface)  THEN
-                   CALL cpu_log( log_point(75), 'usm_radiation', 'start' )
-                   CALL usm_radiation
-                   CALL cpu_log( log_point(75), 'usm_radiation', 'stop' )
+                IF ( urban_surface  .OR.  land_surface  .AND.                  &
+                     radiation_interactions )  THEN
+                   CALL cpu_log( log_point(75), 'radiation_interaction', 'start' )
+                   CALL radiation_interaction
+                   CALL cpu_log( log_point(75), 'radiation_interaction', 'stop' )
                 ENDIF
 
@@ -924,5 +1000,19 @@
 
        ENDDO   ! Intermediate step loop
-
+!
+!--          If required, consider chemical emissions
+!--          (todo (FK): Implement hourly call of emissions, using time_utc from
+!--                      data_and_time_mod.f90;
+!--                      move the CALL to appropriate location)
+! #if defined( __chem )
+!              IF ( air_chemistry ) THEN
+!                 CALL chem_emissions
+!              ENDIF
+! #endif
+!
+!--    If required, do UV exposure calculations
+       IF ( uv_exposure )  THEN
+          CALL uvem_calc_exposure
+       ENDIF
 !
 !--    Increase simulation time and output times
Index: palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- palm/trunk/SOURCE/time_integration_spinup.f90	(revision 2693)
+++ palm/trunk/SOURCE/time_integration_spinup.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file time_integration_spinup.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Added radiation interactions (moved from USM) (MS)
+! 
+! 2544 2017-10-13 18:09:32Z maronga
 ! Date and time quantities are now read from date_and_time_mod 
 ! 
@@ -87,5 +90,6 @@
     USE radiation_model_mod,                                                   &
         ONLY:  dt_radiation, force_radiation_call, radiation,                  &
-               radiation_control, rad_sw_in, time_radiation 
+               radiation_control, rad_sw_in, time_radiation,                   &
+               radiation_interaction, radiation_interactions
 
     USE statistics,                                                            &
@@ -101,5 +105,6 @@
     USE urban_surface_mod,                                                     &
         ONLY:  usm_material_heat_model, usm_material_model,                    &
-               usm_radiation, usm_surface_energy_balance, usm_swap_timelevel
+               usm_surface_energy_balance, usm_swap_timelevel,                 &
+               usm_green_heat_model, usm_temperature_near_surface
 
 
@@ -274,5 +279,9 @@
                 CALL usm_surface_energy_balance
                 IF ( usm_material_model )  THEN
+                   CALL usm_green_heat_model
                    CALL usm_material_heat_model
+                ENDIF
+                IF ( urban_surface ) THEN
+                   CALL usm_temperature_near_surface
                 ENDIF
                 CALL cpu_log( log_point(74), 'urban_surface', 'stop' )
@@ -301,8 +310,8 @@
                 CALL cpu_log( log_point(50), 'radiation', 'stop' )
 
-                IF (urban_surface)  THEN
-                   CALL cpu_log( log_point(75), 'usm_radiation', 'start' )
-                   CALL usm_radiation
-                   CALL cpu_log( log_point(75), 'usm_radiation', 'stop' )
+                IF ( radiation_interactions )  THEN
+                   CALL cpu_log( log_point(75), 'radiation_interaction', 'start' )
+                   CALL radiation_interaction
+                   CALL cpu_log( log_point(75), 'radiation_interaction', 'stop' )
                 ENDIF
              ENDIF
Index: palm/trunk/SOURCE/time_to_string.f90
===================================================================
--- palm/trunk/SOURCE/time_to_string.f90	(revision 2693)
+++ palm/trunk/SOURCE/time_to_string.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file time_to_string.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 2693)
+++ palm/trunk/SOURCE/timestep.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file timestep.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/timestep_scheme_steering.f90
===================================================================
--- palm/trunk/SOURCE/timestep_scheme_steering.f90	(revision 2693)
+++ palm/trunk/SOURCE/timestep_scheme_steering.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file timestep_scheme_steering.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 2693)
+++ palm/trunk/SOURCE/transpose.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file transpose.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/tridia_solver_mod.f90
===================================================================
--- palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/tridia_solver_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file tridia_solver_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file urban_surface_mod.f90
-!--------------------------------------------------------------------------------!
-! This file is part of PALM.
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -26,4 +26,31 @@
 ! -----------------
 ! $Id$
+! - Bugfix in calculation of pt_surface and related fluxes. (BM)
+! - Do not write surface temperatures onto pt array as this might cause 
+!   problems with nesting. (MS)
+! - Revised calculation of pt1 (now done in surface_layer_fluxes).
+!   Bugfix, f_shf_window and f_shf_green were not set at vertical surface 
+!   elements. (MS)
+! - merged with branch ebsolver
+!   green building surfaces do not evaporate yet
+!   properties of green wall layers and window layers are taken from wall layers
+!   this input data is missing. (RvT)
+! - Merged with branch radiation (developed by Mohamed Salim)
+! - Revised initialization. (MS)
+! - Rename emiss_surf into emissivity, roughness_wall into z0, albedo_surf into 
+!   albedo. (MS)
+! - Move first call of usm_radiatin from usm_init to init_3d_model
+! - fixed problem with near surface temperature
+! - added near surface temperature t_surf_10cm_h(m), t_surf_10cm_v(l)%t(m)
+! - does not work with temp profile including stability, ol
+!   t_surf_10cm = pt1 now
+! - merged with 2357 bugfix, error message for nopointer version
+! - added indoor model coupling with wall heat flux
+! - added green substrate/ dry vegetation layer for buildings
+! - merged with 2232 new surface-type structure
+! - added transmissivity of window tiles
+! - added MOSAIK tile approach for 3 different surfaces (RvT)
+! 
+! 2583 2017-10-26 13:58:38Z knoop
 ! Date and time quantities are now read from date_and_time_mod. Solar constant is
 ! read from radiation_model_mod
@@ -142,4 +169,5 @@
 !>    1.2 Km/s, which seem to be not realistic.
 !>
+!> @todo Output of _av variables in case of restarts
 !> @todo Revise flux conversion in energy-balance solver
 !> @todo Bugfixing in nopointer branch 
@@ -148,4 +176,8 @@
 !> @todo Check for load imbalances in CPU measures, e.g. for exchange_horiz_prog
 !>       factor 3 between min and max time
+!> @todo Move setting of flag indoor_model to indoor_model_mod once available
+!> @todo Check divisions in wtend (etc.) calculations for possible division
+!>       by zero, e.g. in case fraq(0,m) + fraq(1,m) = 0?!
+!> @todo Use unit 90 for OPEN/CLOSE of input files (FK)
 !------------------------------------------------------------------------------!
  MODULE urban_surface_mod
@@ -170,15 +202,15 @@
                g, pt_surface, large_scale_forcing, lsf_surf, spinup,           &
                spinup_pt_mean, spinup_time, time_do3d, dt_do3d,                &
-               average_count_3d, varnamelength, urban_surface
+               average_count_3d, varnamelength, urban_surface, kappa
 
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point, log_point_s
-     
+
     USE date_and_time_mod,                                                     &
         ONLY:  d_seconds_year, day_of_year_init, time_utc_init
-   
+
     USE grid_variables,                                                        &
         ONLY:  dx, dy, ddx, ddy, ddx2, ddy2
-    
+
     USE indices,                                                               &
         ONLY:  nx, ny, nnx, nny, nnz, nxl, nxlg, nxr, nxrg, nyn, nyng, nys,    &
@@ -192,12 +224,23 @@
     
     USE plant_canopy_model_mod,                                                &
-        ONLY:  plant_canopy, pch_index,                                        &
-               pc_heating_rate, lad_s
+        ONLY:  pc_heating_rate, plant_canopy, usm_lad_rma
     
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation, calc_zenith, zenith,                                 &
-               rad_net, rad_sw_in, rad_lw_in, rad_sw_out, rad_lw_out,          &
+        ONLY:  albedo_type, radiation, calc_zenith, zenith,                    &
+               rad_sw_in, rad_lw_in, rad_sw_out, rad_lw_out,                   &
                sigma_sb, solar_constant, sun_direction, sun_dir_lat,           &
-               sun_dir_lon, force_radiation_call
+               sun_dir_lon,                                                    &
+               force_radiation_call, surfinsw, surfinlw, surfinswdir,          &
+               surfinswdif, surfoutsw, surfoutlw, surfins,nsvfl, svf, svfsurf, &
+               surfinl, surfinlwdif, energy_balance_surf_h,                    &
+               energy_balance_surf_v, rad_sw_in_dir, rad_sw_in_diff,           &
+               rad_lw_in_diff, surfouts, surfoutl, surfoutsl, surfoutll, surf, &
+               surfl, nsurfl, nsurfs, surfstart, pcbinsw, pcbinlw, pcbl, npcbl, startenergy,      &
+               endenergy, nenergy, iup_u, inorth_u, isouth_u, ieast_u, iwest_u, iup_l,  &
+               inorth_l, isouth_l, ieast_l, iwest_l, startsky, endsky,id,      &
+               iz, iy, ix, idir, jdir, kdir, startborder, endborder, nsurf_type, nzub, nzut,   &
+               isky, inorth_b,idown_a, isouth_b, ieast_b, iwest_b, nzu, pch, nsurf,  &
+               iup_a, inorth_a, isouth_a, ieast_a, iwest_a, idsvf, ndsvf,      &
+               idcsf, ndcsf, kdcsf, pct, startland, endland, startwall, endwall
 
     USE statistics,                                                            &
